#define sqr(x) ((x)*(x))
#define CLASSES 32
#define CLASSES_1 31

double texture_con_d(nr_rows, nr_cols, array)
int nr_rows;
int nr_cols;
double **array;
{
  double nbv, tsum;
  int R, SDM[CLASSES][CLASSES], drow, dcol, distance, windim, angle;
  register int k,l,n;

  windim=1;
  distance=1;
  angle=3;

  nbv=0.0;
  R=0;
  for (k=0;k<CLASSES;k++)
    for (l=0;l<CLASSES;l++)
      SDM[k][l]=0;

/*--------------------------------------------------------------*/
/*  Calculate first half drow, dcolumn                          */
/*--------------------------------------------------------------*/
  switch(angle)
    {
    case 0: drow =         0; dcol =  distance; break;
    case 1: drow = -distance; dcol =  distance; break;
    case 2: drow = -distance; dcol =         0; break;
    case 3: drow = -distance; dcol = -distance; break;
    }

  for(k = 1; k <= 3; ++k)
    for(l = 1; l <= 3; ++l)
      SDM[ (int)(array[k][l])%CLASSES ][ (int)(array[k+drow][l+dcol])%CLASSES ]++,R++;

/*--------------------------------------------------------------*/
/*  Calculate second half drow, dcolumn                         */
/*--------------------------------------------------------------*/
  switch(angle)
    {
    case 0: drow =        0; dcol = -distance; break;
    case 1: drow = distance; dcol = -distance; break;
    case 2: drow = distance; dcol =         0; break;
    case 3: drow = distance; dcol =  distance; break;
    }

  for(k = 1; k <= 3; ++k)
    for(l = 1; l <= 3; ++l)
      SDM[ (int)(array[k][l])%CLASSES ][ (int)(array[k+drow][l+dcol])%CLASSES ]++,R++;

/*--------------------------------------------------------------*/
/*  Contrast                                                    */
/*--------------------------------------------------------------*/
  if (R)
    for (n=0;n<CLASSES_1;++n){
      tsum=0.0;
      for(k = 0; k < CLASSES; ++k)
        for(l = 0; l < CLASSES; ++l)
	  if ((k-l)==n) tsum += (double)SDM[k][l] / (double)R;
      nbv+=tsum*sqr(n);
    }
  else
    nbv = -1.0;

  return nbv;
}
/*
Additional kernel C/ErMapper code implemeted for educational purposes.
Copyright (C) 1992-2011 Ch Iossif - chiossif@yahoo.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

